100   SCReen_init
110   intro
120   REMark CREATE AND SORT INTEGER ARRAY
130   PRINT #4;"Creating"!max!"random integers"
140   DIM int%(max)
150   randnum int%
160   start_time=DATE
170   sort int%
180   time_i =DATE-start_time
190   PRINT #4; "Integer array sorted in ";time_i!" seconds"
200   print_array int%
210   :
220   wait
230   REMark CREATE AND SORT FLOATING POINT ARRAY
240   PRINT #4;"Creating"!max!"random floats"
250  DIM flt(max)
260  randnum flt
270  start_time=DATE
280  sort flt
290  time_f=DATE-start_time
300  PRINT #4; "Float array sorted in ";time_f!"seconds"
310  print_array flt
320 :
330  wait
340  REMark CREATE AND SORT NUMERIC STRING ARRAY
350  PRINT #4;"Creating"!max!"random numeric strings"
360  DIM str$(max,4)
370  randnum str$
380  start_time=DATE
390  sort str$
400  time_n=DATE-start_time
410  PRINT #4;"String array sorted in ";time_n!"seconds"
420  print_array str$
430  :
440  wait
450  REMark CREATE AND SORT ALPHA STRING ARRAY
460  PRINT #4;"Creating"!max!"random alpha strings"
470  randchar str$
480  start_time=DATE
490  sort str$
500  time_a=DATE-start_time
510  PRINT #4;"Alpha strings sorted in ";time_a;" seconds"
520  print_array str$
530  wait
540  :
550  REMark PRINT RESULTS
560  CLS #5: AT #5,2,0
570  j$="Q_Liberator"
580  IF Q_MYJOB=0 THEN j$="Interpreter"
590  PRINT #5,\"     Sort times for"!j$
600  PRINT #5,\"   Integer array           : ";time_i
610  PRINT #5,\"   Float point array       : ";time_f
620  PRINT #5,\"   String array, numeric   : ";time_n
630  PRINT #5,\"   String array, alpha     : ";time_a
640  wait
650  STOP
660 :
670 DEFine PROCedure print_array(ara)
680  CLS #5: PRINT #5,ara(1 TO)!
690 END DEFine print_array
700 :
710 DEFine PROCedure randchar(ara)
720   LOCal i,j
730   FOR i=1 TO DIMN(ara,1)
740     FOR j=1 TO DIMN(ara,2)
750       ara(i,j)=CHR$(RND(65 TO 90))
760     END FOR j
770     ara(i,0)=DIMN(ara,2)
780   END FOR i
790   CLS #5: PRINT #5,ara(1 TO)!
800 END DEFine randchar
810 :
820 DEFine PROCedure randnum(ara)
830   LOCal i
840   FOR i=1 TO DIMN(ara)
850     ara(i)=RND(1000 TO 9999)
860   END FOR i
870   CLS #5: PRINT #5,ara(1 TO)!
880   wait
890 END DEFine random
900 :
910 DEFine PROCedure SCReen_init
920   OPEN #3 ;"scr_512X256a0x0"  : REMark clear screen
930   CLS #3
940   OPEN #3;"SCR_448x24a32x16"  :  REMark Q_Liberator window
950   OPEN #4;"CON_448x40a32x200" :  REMark command window
960   OPEN #5 ;"CON_448x160a32x40": REMark result window
970   BORDER #3,1,7 : BORDER #4,1,7 : BORDER #5,1,7
980   PAPER #5,0 : INK #5,4 : CLS #5 : CSIZE #5,2,0
990   CSIZE #4,2,0
1000   PAPER #3,0 : INK #3,4 : CLS #3
1010   CSIZE #3;3,1 : OVER #3,1
1020   ql$="Q_Liberator   demo_sort"
1030   INK #3,2:PRINT #3;ql$;  : CURSOR #3,1,1
1040   INK #3,4:PRINT #3;ql$;  : CURSOR #3,2,2
1050 END DEFine
1060 :
1070 DEFine PROCedure intro
1080   PRINT #5;"This program shows the dramatic"
1090   PRINT #5;"speed increase which Q_Liberator can"
1100   PRINT #5;"impart to a program."\\
1110   PRINT #5;"It creates arrays of random numbers"
1120   PRINT #5;"or characters and sorts them into"
1130   PRINT #5;"ascending order."\\
1140   PRINT #5;"The sort procedure is adapted from"
1150   PRINT #5;"that described on page 100 of the"
1160   PRINT #5;"QL User Guide."\\
1170   PRINT #5;"Note that the one procedure can"
1180   PRINT #5;"be used to sort any type of array."\\
1190   INPUT #4;"How many elements (10-100) ";max$
1200   max=0&max$:
1210   SELect ON max
1220     =10 TO 100
1230     =REMAINDER : max=100
1240   END SELect
1250 END DEFine intro
1260 :
1270 DEFine PROCedure sort(ara)
1280 REMark $$i
1290 REMark Insertion Sort
1300   PRINT #4;"Sorting ... "
1310   BEEP 500,20
1320   IF DIMN(ara)<2 THEN RETurn
1330   FOR item=2 TO DIMN(ara)
1340     p%=item
1350     ara(0)=ara(p%)
1360     REPeat compare
1370       IF ara(0)>=ara(p%-1):EXIT compare
1380       ara(p%)=ara(p%-1)
1390       p%=p%-1
1400     END REPeat compare
1410     ara(p%)=ara(0)
1420   END FOR item
1430   CLS #4
1440 REMark $$f
1450 END DEFine
1460 :
1470 DEFine PROCedure wait
1480   PRINT #4,\"Hit space to continue"
1490   BEEP 500,20
1500   REPeat waiting
1510     IF CODE(INKEY$(#4; -1)) = 32 THEN EXIT waiting
1520   END REPeat waiting
1530   CLS #4
1540 END DEFine wait
1550 :
